#include<stdio.h>
#include<stdlib.h>

#include<mod.h>

struct SSS_Protocol *ssl_LTX_get_state(SSS_ConfigDict cfg,int debug,int *error){
  struct SSS_Protocol *ret;

  ret = malloc(sizeof(struct SSS_Protocol));

  ret->modules = mod_init(cfg,debug,"ssl","bytecount","challenge","none");
  if (!ret->modules){
    *error = SSS_LIBRARY_ERROR;
    return NULL;
  }

  ret->debug = debug;
  
  return ret;

}

int ssl_LTX_serv_connect(struct SSS_Protocol *state,int extra){
  int rc;
  rc = mod_serv_connect(state->modules,extra);
  if (rc == -1)
    memcpy(&(state->prot_errno),state->modules,sizeof(int));
  return rc;
}

int ssl_LTX_cli_connect(struct SSS_Protocol *state,char *host,int extra){
  int rc;
  rc = mod_cli_connect(state->modules,host,extra);
  if (rc == -1)
    memcpy(&(state->prot_errno),state->modules,sizeof(int));
  return rc;
}

int ssl_LTX_send_message(struct SSS_Protocol *state,char *msg){
  int rc;
  rc = mod_send_message(state->modules,msg);
  if (rc == -1)
    memcpy(&(state->prot_errno),state->modules,sizeof(int));
  return rc;
}

char *ssl_LTX_recv_message(struct SSS_Protocol *state){
  char *ret;
  ret = mod_recv_message(state->modules);
  if (!ret)
    memcpy(&(state->prot_errno),state->modules,sizeof(int));
  return ret;
}

int ssl_LTX_close_conn(struct SSS_Protocol *state){
  int rc;
  rc = mod_close(state->modules);
  if (rc == -1)
    memcpy(&(state->prot_errno),state->modules,sizeof(int));
  return rc;
}
