#!/usr/bin/env python

from MySQLdb import connect
from sys import argv,exit,stdin
from telnetlib import Telnet
from os import getuid
from threading import Thread
from string import rstrip
from sss.ssslib import comm_lib, LookupError
from sss.server import SSSSelectEventReceiver
from xml.dom.minidom import Document,parse,parseString

def power_action(nodelist,action):
    controller_actions = {}
    if getuid():
        print "You must be root to run city_power!"
        exit(1)
    query = Document()
    wrapper = query.createElement('power-control')
    wrapper.setAttribute('type',action)
    for node in nodelist:
        newel = query.createElement('node-hardware')
        newel.setAttribute('node',node)
        wrapper.appendChild(newel)
    query.appendChild(wrapper)
    print query.toxml()
    hsh = comm.ClientInit('build-system')
    comm.SendMessage(hsh,query.toxml())
    answer = comm.RecvMessage(hsh)
    comm.ClientClose(hsh)
    domobj = parseString(answer)#will we be getting an answer?
    if domobj.documentElement.tagname != 'node-hardware-set':
        print "Command failed"
    retlist=map(lambda x:x.getAttribute('node'),domobj.documentElement.childNodes)
    for node in [x for x in retlist if x not in nodelist]:
        print "node %s power control failed"%(node)
   
if __name__ == "__main__":
    if not argv[-1] == '-':
        if len(argv) < 3:
            print "Usage: city_power <on|off|reboot> [-g group] [node] [node2] ..."
            exit(1)
        action = argv[1]
        comm = comm_lib(debug=('-d' in argv))
        if argv[2]=="-g":
            tag = argv[3]
            query = Document()
            wrapper = query.createElement('get-tag')
            newel = query.createElement('tag')
            newel.setAttribute('tag',tag)
            newel.setAttribute('node','*')
            wrapper.appendChild(newel)
            query.appendChild(wrapper)
            bsh = comm.ClientInit('build-system')
            comm.SendMessage(bsh,query.toxml())
            answer = comm.RecvMessage(bsh)
            comm.ClientClose(bsh)
            domobj = parseString(answer)
            nodelist=map(lambda x:domobj.getElementsByTagName("tag").__getitem__(x).getAttribute('node'),range(0,len(domobj.getElementsByTagName("tag"))))
        else:
            nodelist = argv[2:]
        if action not in ['on','off','reboot']:
            print "Usage: city_power <on|off|reboot> [-g group] [node] [node2] ..."
            exit(1)
        power_action(nodelist,action)
    else:
        if not len(argv) == 3:
            print "Usage: city_power <on|off|reboot> -"
            exit(1)
        action = argv[1]
        nodelist = map(rstrip,stdin.readlines())
        power_action(nodelist,action)
